--[[
		Xer0X (tm) CopyLeft (c) 2019 
	    Super Ultra Extra Total Dialogs & Panels 
		Auto ReSiZzer (tm) & MuVvier (tm) 

	Resizes and moves all the Far Manager dialogs 
			with ease!
	-----------------------------------------------

	With love and devotion, to those brave people 
	who is dare enough for use Far Manager in 2020 
	-----------------------------------------------

	DISCLAIMER
	The script's administration is not responsible 
	for  any  use, or  misuse,  or  any  kind  of 
	unexpected  or  disappointing   behaviour 
	while running  the  supplied  script.
	Use  carefully  on  your  own responsibility.
	-----------------------------------------------

--]]

--[[	TODO SECTION: 

1.)	move configs above to ini-file

2.) 	add dialog/window GUIDs not to resize

3.) 	add specific handling to dialog/windows by it's GUIDs, 
	i.e. apply certain rules to specific guids, 
	as for example: 
		a.) this windows (guids) always put in full screen
		b.) those do not ever touch
		c.) .. etc .. ?

4.)	probably, improve isolation between windows types, currently it MAY interfere each other
	that is not critical, since switchin by F5 seems to work flawlessly

5.)	add more modes ? as for example 60%, 70%, 80%, 90% ?

6.)	to write thorough documentation to help people find it and use it

7.)	(to fix) Too complex dialogs with many elements also hidden, 
	as for example "plugin configuration/netbox/transfer settings"
	we are still not perfect:

	Original:

╔═════════════════════ NetBox - Transfer settings ═════════════════════╗
║──────────── Transfer mode ─────────────────── Upload options ────────║
║ ( ) Text (plain text, html, ...)       [ ] Set permissions           ║
║ (•) Binary (archives, doc, ...)        Owner   [x] R  [x] W  [ ] X   ║
║ ( ) Automatic                          Group   [x] R  [ ] W  [ ] X   ║
║ Transfer following files in text mod   Other   [x] R  [ ] W  [ ] X   ║
║ l; *.css; *.cfg; *.ini; *.sh; *.xml ↓  Octal   0644                  ║
║──────── Filename modification ──────── [x] Add X to directories      ║
║ (•) No change       ( ) Upper case     [ ] Ignore permission errors  ║
║ ( ) First upper     ( ) Lower case     [ ] Clear 'Archive' attribute ║
║ ( ) Lower case 8.3  [x] Replace \:*"? ─────── Common options ─────── ║
║────────── Download options ─────────── [x] Preserve timestamp        ║
║ [ ] Preserve read-only                 [x] Calculate total size      ║
╟─────────────────────────────── Other ────────────────────────────────╢
║ File mask (example: *|.svn/)           Speed (KB/s)   Unlimited     ↓║
║                                     ↓                                ║
╟──────────────────────────────────────────────────────────────────────╢
║                          { Ok } [ Cancel ]                           ║
╚══════════════════════════════════════════════════════════════════════╝


	Resized:

╔═══════════════════════════════════════════════════════ NetBox - Transfer settings ════════════════════════════════════════════════════════╗
║──────────── Transfer mode ────────────────────────────────────────────────────── Upload options ──────────────────────────────────────────║
║ ( ) Text (plain text, html, ...)       [ ] Set permissions                                                                                ║
║ (•) Binary (archives, doc, ...)        Owner   [x] R  [x] W  [ ] X                                                                        ║
║ ( ) Automatic                          Group   [x] R  [ ] W  [ ] X                                                                        ║
║ Transfer following files in text mod   Other   [x] R  [ ] W  [ ] X                                                                        ║
║ htm; *.txt; *.php; *.php3; *.cgi; *.c; Octal  *0644                                                                      i; *.sh; *.xml ↓ ║
║────────────────────────────────────────[x] Add X to directoriesme modification ────────────────────────────────────────────────────────── ║
║ (•) No change       ( ) Upper case     [ ] Ignore permission errors                                                                       ║
║ ( ) First upper     ( ) Lower case     [ ] Clear 'Archive' attribute                                                                      ║
║ ( ) Lower case 8.3  [x] Replace \:*"? ───────────────────────────────────────── Common options ────────────────────────────────────────── ║
║────────────────────────────────────────[x] Preserve timestampownload options ──────────────────────────────────────────────────────────── ║
║ [ ] Preserve read-only                 [x] Calculate total size                                                                           ║
╟────────────────────────────────────────────────────────────────── Other ──────────────────────────────────────────────────────────────────╢
║ File mask (example: *|.svn/)           Speed (KB/s)   Unlimited                                                                          ↓║
║                                     ↓                                                                                                     ║
╟───────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────╢
║                                                             { Ok } [ Cancel ]                                                             ║
╚═══════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════════╝

8.)	Probably fix to disk menu going centered

9.)	Probably clean up the code related to performance, i.e. do not call resize dialog routine, when we only moving the dialog

--	END OF TODO SECTION	--]]


-- #################################


--[[	SETTINGS SECTION	--]]

local layout_sizing_type = "margin" 
-- "margin" ==> "full" ==> "original" ==> "percent" ==> "margin" ==> "full" ==> (.. and so on)
local layout_margin_width = 4
local layout_percent_width = 70

local lua_exp_timer
--[[ END OF SETTINGS SECTION --]]

local _dlg_info_mcr,_dlg_info_evt, _hDlg, _hDlg_evt, _hDlg_mcr, _dlg_guid, _dlg_guid_evt, _dlg_guid_mcr, _evt, _dlg_is_menu, _dlg_is_menu_evt, _dlg_is_menu_mcr, _layout_custom_cmd
local _dlg_geometry_orig = {}
local _dlg_position_orig = {}
local _dlg_items_orig = {}

function _dlg_is_list_menu_fnc(dlg_info) return
	type(dlg_info.Flags) == "number" and 
	type(dlg_info.Type) == "number" and 
	type(dlg_info.Id) == "number" and 
	type(dlg_info.Pos) == "number" and 	
	type(dlg_info.TypeName) == "string" and 
	type(dlg_info.Name) == "string" and  	
	dlg_info.Flags < 5 and 
	dlg_info.TypeName == "Panels" and 
	dlg_info.Type < 5 and 
	dlg_info.Id < 5 and 
	dlg_info.Pos < 5
end

function _elem_is_inside_full(elem1, elem2) return
	elem2[2] <= elem1[2] and 
	elem2[3] <= elem1[3] and 
	elem2[4] >= elem1[4] and 
	elem2[5] >= elem1[5] 
end

function _resize(sender) 
	local cons_geometry = far.AdvControl("ACTL_GETFARRECT")
	local cons_width = cons_geometry.Right - cons_geometry.Left + 1
	local cons_height = cons_geometry.Bottom - cons_geometry.Top + 1
	local dlg_geometry = far.SendDlgMessage(_hDlg, far.Flags.DM_GETDLGRECT)
	local rest_orig = false
	if _dlg_geometry_orig[_dlg_guid] == nil or sender == "event" then 
		_layout_custom_cmd = "" 
		_dlg_geometry_orig[_dlg_guid] = dlg_geometry;
		_dlg_position_orig[_dlg_guid] = dlg_position;
		_dlg_items_orig[_dlg_guid] = {}
		for dlgii = 0, 200, 1 do 
			dlgi = far.GetDlgItem(_hDlg, dlgii)
			if dlgi then _dlg_items_orig[_dlg_guid][dlgii] = dlgi; end 
		end
	end 
	local orig_width = _dlg_geometry_orig[_dlg_guid].Right - _dlg_geometry_orig[_dlg_guid].Left + 1 
	local orig_height = _dlg_geometry_orig[_dlg_guid].Bottom - _dlg_geometry_orig[_dlg_guid].Top + 1 
	local curr_width = dlg_geometry.Right - dlg_geometry.Left + 1
	local curr_height = dlg_geometry.Bottom - dlg_geometry.Top + 1

	local targ_width 
	if _layout_custom_cmd and _layout_custom_cmd > "" 
	then -- incremental interactive manipulations
		local size_new = {X = curr_width, Y = curr_height}
		local location_new = {X = 0, Y = 0}
		if	_layout_custom_cmd == "AltRight" 
		then	size_new.X = size_new.X + 1
		elseif	_layout_custom_cmd == "AltLeft" 
		then	size_new.X = size_new.X + 1
			location_new.X = -1
		elseif	_layout_custom_cmd == "CtrlAltRight" 
		then	size_new.X = size_new.X - 1
			location_new.X = 1
		elseif	_layout_custom_cmd == "CtrlAltLeft" 
		then	size_new.X = size_new.X - 1
		elseif	_layout_custom_cmd == "CtrlAltUp" 
		then	location_new.Y = -1
		elseif	_layout_custom_cmd == "CtrlAltDown" 
		then	location_new.Y = 1
		end
		_dlg_position_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_MOVEDIALOG, 0, location_new)
		_dlg_geometry_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_RESIZEDIALOG, 0, {X = size_new.X, Y = size_new.Y})
		targ_width = _dlg_geometry_curr.X 
	else -- predefined layout
		if 	layout_sizing_type == "margin" 
		then 	targ_width = cons_width - layout_margin_width
		elseif	layout_sizing_type == "percent" 
		then	targ_width = cons_width * layout_percent_width / 100
		elseif	layout_sizing_type == "full"  
		then	targ_width = cons_width
		elseif	layout_sizing_type == "original"  
		then	targ_width = orig_width
			rest_orig = true
		end 
		if rest_orig then 
			_dlg_position_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_MOVEDIALOG, 1, {X = _dlg_geometry_orig[_dlg_guid].Left, Y = _dlg_geometry_orig[_dlg_guid].Top})
			_dlg_geometry_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_RESIZEDIALOG, 0, {X = targ_width, Y = orig_height})
		else 
			_dlg_position_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_MOVEDIALOG, 1, {X = (cons_width - targ_width) / 2, Y = _dlg_geometry_orig[_dlg_guid].Top})
			_dlg_geometry_curr = far.SendDlgMessage(_hDlg, far.Flags.DM_RESIZEDIALOG, 0, {X = targ_width, Y = orig_height})
		end
	end
	local delta_width = targ_width - curr_width
	local max_height, dlgi, dlgi_new = 0, nil, nil
	for dlgii = 0, 1000, 1 do
		dlgi = far.GetDlgItem(_hDlg, dlgii)
		if not dlgi and dlgi_new then break; end
		dlgi_new = dlgi
		if dlgi then
			max_height = math.max(max_height, dlgi[5]) -- where dlgi[5] is Y2
			local modified = false

			if rest_orig then 
				dlgi_new = _dlg_items_orig[_dlg_guid][dlgii] 
				if dlgi_new then modified = true end
			else
				if dlgi[4] > 0 then 
					local targ_item_width = math.max(targ_width - dlgi[2] - 2, dlgi[4] + delta_width) 
					if	_dlg_is_menu 
					then 
						dlgi_new[4] = targ_item_width
						modified = true
					else 
						dlgi_next = far.GetDlgItem(_hDlg, dlgii + 1)
						if not dlgi_next or _elem_is_inside_full(dlgi_next, dlgi) or dlgi_next[3] > dlgi[3] 
						then 
							dlgi_new[4] = targ_item_width;
							modified = true
						end 
					end
				end
			end
			if modified then 
				far.SetDlgItem(_hDlg, dlgii, dlgi_new) 
			end
		end
	end
end

Event { description="";
	id = "3AFC2AA4-9638-4C59-8602-7A25ECD87126";
	group = "DialogEvent";
	condition = function(evt, fde) return true; end;
	action = function(evt, fde) 
-- ###
if evt == far.Flags.DE_DLGPROCINIT and fde.Msg == far.Flags.DN_INITDIALOG then 
	_G._fde_test = fde
	_G._evt_test = evt
	local	dlg_info = far.SendDlgMessage(fde.hDlg, far.Flags.DM_GETDIALOGINFO) 
	if not	dlg_info then 
		dlg_info = far.AdvControl(far.Flags.ACTL_GETWINDOWINFO, nil)
	else 
	end

	_G._dlg_info_test = dlg_info 
	if dlg_info then 
		local dlg_is_menu = _dlg_is_list_menu_fnc(dlg_info)
		if 	dlg_info.Id and 
			not dlg_info.TypeName and 
			type(dlg_info.Id) == "string" 
		then 
			if pcall(function() dlg_guid = win.Uuid(dlg_info.Id):upper() end) then end
			if dlg_guid == nil then dlg_guid = tostring(dlg_info.Id) end
		else 
			surr_id = mf.iif(dlg_info.Id, tostring(dlg_info.Id), "-1")
			dlg_guid = "Id="..surr_id..";Type="..dlg_info.Type..";TypeName="..dlg_info.TypeName..";Flags="..tostring(dlg_info.Flags)
		end 
		if dlg_guid == "4406C688-209F-4378-8B7B-465BF16205FF" then return false; end
		if dlg_guid == "7646F761-8954-42CA-9CFC-E3F98A1C54D3" then return false; end 

		_dlg_guid = dlg_guid
		_dlg_guid_evt = dlg_guid
		_dlg_info_evt = dlg_info 
		_evt = evt 
		_fde = fde 
		_hDlg_evt = fde.hDlg
		_hDlg = fde.hDlg
		_dlg_is_menu_evt = dlg_is_menu
		_dlg_is_menu = dlg_is_menu
		_layout_custom_cmd = ""
		_resize("event")
	end;
end 
return false; 
--- @@@
end 
}

Macro { description = "";
	id = "B4536879-7071-4619-8F9C-6DBE59E3B6E2";
	area = "Other Dialog MainMenu UserMenu Disks";
	key = "F5 CtrlAltRight CtrlAltLeft AltRight AltLeft CtrlAltUp CtrlAltDown";
	condition = function(key) return true end;
	action = function() 
--- ###

local dlg_guid = Area.Dialog and Dlg.Id or Menu.Id
-- drop down box for free text:
if dlg_guid == "4406C688-209F-4378-8B7B-465BF16205FF" then return false end

local dlg_info = far.AdvControl(far.Flags.ACTL_GETWINDOWINFO, nil)
local dlg_is_menu = _dlg_is_list_menu_fnc(dlg_info)

_dlg_info_mcr = dlg_info;
_hDlg_mcr = _dlg_info_mcr.Id
_dlg_guid_mcr = dlg_guid
_dlg_is_menu_mcr = dlg_is_menu

_dlg_guid = mf.iif(_dlg_info_mcr.Id == _fde.hDlg, _dlg_guid_evt, _dlg_guid_mcr)
_hDlg = _hDlg_mcr
_dlg_is_menu = dlg_is_menu

if akey(1, 0) == "F5" 
then 
	_layout_custom_cmd = ""
	if	layout_sizing_type == "margin" 
	then	layout_sizing_type =  "full" 
	elseif	layout_sizing_type == "full" 
	then	layout_sizing_type =  "original" 
	elseif	layout_sizing_type == "original" 
	then 	layout_sizing_type =  "percent" 
	elseif 	layout_sizing_type == "percent" 
	then	layout_sizing_type =  "margin" 
	end
else 
	_layout_custom_cmd = akey(1, 0):gsub("RAlt", "Alt"):gsub("RCtrl", "Ctrl")
end

_resize("macros")
--- @@@
end;
}